import { __extends } from 'tslib';
import { Component, ElementRef, Input, Optional, Self, Inject, NgModule } from '@angular/core';
import { NgControl, NgForm, FormGroupDirective } from '@angular/forms';
import { ErrorStateMatcher } from '@angular/material/core';
import { MatFormFieldControl } from '@angular/material/form-field';
import { CodemirrorComponent, WA_CODEMIRROR_DEFAULTS, CodemirrorModule } from '@webacad/ng-codemirror';
import { Subject } from 'rxjs';
import 'codemirror';

var nextUniqueId = 0;
var MatCodemirrorComponent = /** @class */ (function (_super) {
    __extends(MatCodemirrorComponent, _super);
    function MatCodemirrorComponent(el, _defaultErrorStateMatcher, _parentForm, _parentFormGroup, ngControl, defaults) {
        var _this = _super.call(this, el, defaults) || this;
        _this._defaultErrorStateMatcher = _defaultErrorStateMatcher;
        _this._parentForm = _parentForm;
        _this._parentFormGroup = _parentFormGroup;
        _this.ngControl = ngControl;
        _this.required = false;
        _this.errorState = false;
        _this.stateChanges = new Subject();
        _this.shouldLabelFloat = true;
        _this._disabled = false;
        _this._uid = "wa-codemirror-" + nextUniqueId++;
        if (_this.ngControl !== null) {
            _this.ngControl.valueAccessor = _this;
        }
        return _this;
    }
    Object.defineProperty(MatCodemirrorComponent.prototype, "value", {
        get: function () {
            return this.codemirror ? this.codemirror.getValue() : '';
        },
        set: function (value) {
            if (this.codemirror) {
                if (value !== this.value) {
                    this.codemirror.setValue(value);
                    this.stateChanges.next();
                }
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(MatCodemirrorComponent.prototype, "disabled", {
        get: function () {
            if (this.ngControl && this.ngControl.disabled !== null) {
                return this.ngControl.disabled;
            }
            return this._disabled;
        },
        set: function (disabled) {
            this._disabled = disabled;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(MatCodemirrorComponent.prototype, "id", {
        get: function () {
            return this._id;
        },
        set: function (id) {
            this._id = id || this._uid;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(MatCodemirrorComponent.prototype, "empty", {
        get: function () {
            return this.value !== '';
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(MatCodemirrorComponent.prototype, "focused", {
        get: function () {
            if (this.codemirror) {
                return this.codemirror.hasFocus();
            }
            return false;
        },
        enumerable: true,
        configurable: true
    });
    MatCodemirrorComponent.prototype.ngOnChanges = function (changes) {
        _super.prototype.ngOnChanges.call(this, changes);
        if (typeof changes['value'] !== 'undefined' || typeof changes['required'] !== 'undefined') {
            this.stateChanges.next();
        }
    };
    MatCodemirrorComponent.prototype.ngDoCheck = function () {
        if (this.ngControl) {
            this.updateErrorState();
        }
    };
    MatCodemirrorComponent.prototype.ngOnDestroy = function () {
        this.stateChanges.complete();
    };
    MatCodemirrorComponent.prototype.onContainerClick = function (event) {
        this.focus();
    };
    MatCodemirrorComponent.prototype.focus = function () {
        if (this.codemirror) {
            this.codemirror.focus();
            this.stateChanges.next();
        }
    };
    MatCodemirrorComponent.prototype.updateErrorState = function () {
        var oldState = this.errorState;
        var parent = this._parentFormGroup || this._parentForm;
        var matcher = this.errorStateMatcher || this._defaultErrorStateMatcher;
        var control = this.ngControl ? (this.ngControl.control) : null;
        var newState = matcher.isErrorState(control, parent);
        if (newState !== oldState) {
            this.errorState = newState;
            this.stateChanges.next();
        }
    };
    MatCodemirrorComponent.prototype.setDescribedByIds = function (ids) {
    };
    return MatCodemirrorComponent;
}(CodemirrorComponent));
MatCodemirrorComponent.decorators = [
    { type: Component, args: [{
                selector: 'wa-mat-codemirror',
                template: '',
                providers: [
                    {
                        provide: MatFormFieldControl,
                        useExisting: MatCodemirrorComponent,
                    },
                ],
            },] },
];
MatCodemirrorComponent.ctorParameters = function () { return [
    { type: ElementRef, },
    { type: ErrorStateMatcher, },
    { type: NgForm, decorators: [{ type: Optional },] },
    { type: FormGroupDirective, decorators: [{ type: Optional },] },
    { type: NgControl, decorators: [{ type: Self }, { type: Optional },] },
    { type: undefined, decorators: [{ type: Inject, args: [WA_CODEMIRROR_DEFAULTS,] }, { type: Optional },] },
]; };
MatCodemirrorComponent.propDecorators = {
    "placeholder": [{ type: Input },],
    "required": [{ type: Input },],
    "errorStateMatcher": [{ type: Input },],
    "value": [{ type: Input },],
    "disabled": [{ type: Input },],
    "id": [{ type: Input },],
};
var MatCodemirrorModule = /** @class */ (function () {
    function MatCodemirrorModule() {
    }
    return MatCodemirrorModule;
}());
MatCodemirrorModule.decorators = [
    { type: NgModule, args: [{
                imports: [
                    CodemirrorModule,
                ],
                declarations: [
                    MatCodemirrorComponent,
                ],
                exports: [
                    CodemirrorModule,
                    MatCodemirrorComponent,
                ],
            },] },
];

export { MatCodemirrorComponent, MatCodemirrorModule };
//# sourceMappingURL=webacad-ng-mat-codemirror.js.map
